#ifndef IMAGICH
#define IMAGICH

struct imagicH {
int imnum;	// image number
int count;	// total # images in file (1st record only)
int error;
int headrec;	// # header records/image
int mday;
int month;
int year;
int hour;
int minute;
int sec;
int reals;	// image size in reals
int pixels;	// image size in pixels
int ny;
int nx;
char type[4];	// usu 'REAL', or 'INTG'
int ixold;
int iyold;
float avdens;	// average density
float sigma;	// deviation of density
float varia;	// variance
float oldav;	// old average dens
float max;	// max dens
float min;	// min dens
int complex;	// ?
float cellx;
float celly;
float cellz;
float cella1;
float cella2;
char label[80];	//30
int SPACE[8];	//50
float MRC1[4];	//58
int MRC2;	//62
int SPACE2[7];
int lbuf;		// effective buffer len = nx
int inn;		// lines in buffer = 1
int iblp;		// buffer lines/image = ny
int ifb;		// 1st line in buf = 0
int lbr;		// last buf line read = -1
int lbw;		// last buf line written = 0
int lastlr;		// last line called for read = -1
int lastlw;		// last line called for write = 1
int ncflag;		// decode to complex = 0
int num;		// file number = 40 (?)
int nhalf;		// leff/2
int ibsd;		// record size for r/w (words) = nx*2
int ihfl;		// file # = 8
int lcbr;		// lin count read buf = -1
int lcbw;		// lin count wr buf = 1
int imstr;		// calc stat on rd = -1
int imstw;		// calc stat on wr = -1
int istart;		// begin line in buf = 1
int iend;		// end line in buf = nx
int leff;		// eff line len	= nx
int linbuf;		// line len (16 bit) nx *2
int ntotbuf;	// total buf in pgm = -1
int SPACE3[5];
int icstart;	// complex line start = 1
int icend;		// complex line end = nx/2
int rdonly;		// read only = 0

int clsrep;		// EMAN specific, classes represented with 0x7a6b5c00 mask
int emanmisc[6];
float qual[50];	// quality info from EMAN classification
int cls[50];	// number of best class
int flags[50];	// eman flags
};


/** IMAGIC-5 file format from
 * http://www.imagescience.de/formats/formats.htm
 * EMAN will read both old and new Imagic header,
 * but write to new format from 11/18/2009(Grant).
 * */
struct imagic5H {
int imnum;	//1 image location number (1,2,3,...)
int count;	//2 total # images in file (1st record only)
int error;	//3 error code for this image during IMAGIC-5 run
int headrec;//4 number of header records per image (=1 always)
int month;	//5 creation month
int mday;	//6	creation day
int year;	//7 creation year
int hour;	//8 creation hour
int minute; //9	creation minute
int sec;	//10 creation second
int reals;	//11 image size in reals (bytes)
int pixels;	//12 image size in pixels
int ny;		//13 number of lines per image (for 1D data IYLP1=1)
int nx;		//14  number of pixels per line
char type[4];	//15 only 'REAL', or 'INTG' are implemented for EMAN
				// 4 characters determining the image type
				// REAL : REAL/float
				// INTG : INTEGER*2/short
				// PACK : PACK/byte
				// COMP : 2 REAL / 2 float
				// RECO : complex format with 0 in imaginary part)
int ixold;	//16  top left X co-ordinate before CUT-IMAGE (boxing)
int iyold;	//17  top left Y co-ordinate before CUT-IMAGE (boxing)
float avdens;	//18 average density
float sigma;	//19 standard deviation of density
float varia;	//20 variance of densities in image
float oldav;	//21 old average density
float max;	//22 max density in image
float min;	//23 min density in image
int complex;	//24 label indicating that data is always complex
float cxlength;	//25 cell dimension in Angstr. (x-direction) (MRC(12))
float cylength;	//26 cell dimension in Angstr. (y-direction) (MRC(11))
float czlength;	//27 cell dimension in Angstr. (z-direction) (MRC(13))
float calpha;	//28 cell angle alpha (MRC(14))
float cbeta;	//29 cell angle beta (MRC(15))
char label[80];	//30-49 coded NAME/TITLE of the image (80 characters)
float cgamma;	//50 cell angle gamma (MRC(16))
int mapc;		//51 axis corresponding to columns (MRC(17)) (1,2,3 for X,Y,Z)
int mapr;		//52 axis corresponding to rows (MRC(18)) (1,2,3 for X,Y,Z)
int maps;		//53 axis corresponding to sections (MRC(19))
int ispg;		//54 space group (MRC(23))
int nxstart;	//55 number of 1st column in map (def:0) (MRC(6)) (where map starts in columns)
int nystart;	//56 number of 1st row in map (def:0) (MRC(5)) (where map starts in rows)
int nzstart;	//57 number of 1st section in map (def:0) (MRC(7)) (where map starts in sections)
int nxintv;		//58 number of intervals along X (MRC(9))
int nyintv;		//59 number of intervals along Y (MRC(8))
int nzintv;		//60 number of intervals along Z (MRC(10))
int izlp;		//61 number of 2D planes in 3D data (for 2D: IZLP1=1)
int i4lp;		//62 number of 3D volumes in 4D data (for 2D: I4LP1=1)
int i5lp;		//63
int i6lp;		//64
float alpha;	//65 Euler angle alpha (3D and Angular Reconst.)
float beta;		//66 Euler angle beta (3D and Angular Reconst.)
float gamma;	//67 Euler angle gamma (3D and Angular Reconst.)
int imavers;	//68 IMAGIC-5 version used (yyyymmdd)
int realtype;	//69  floating point type, machine stamp
				// 16777216 for VAX/VMS
				// 33686018 for OSF,ULTRIX, LINUX, MS Windows
				// 67372036 for SiliconGraphics, SUN, HP, IBM
char buffer[116];		//70-98	 Variables that control the buffering
						// during read/write in IMAGIC-5 programs.
						// PLEASE DO NOT TOUCH !
int ronly;		//99  flag in calling program to open file readonly  (1: readonly)
float angle;	//100 last rotation angle
float rcp;		//101 rotational correlation peak
int ixpeak;		//102 shift correlation peak in X direction
int iypeak;		//103 shift correlation peak in Y direction
float ccc;		//104 cross correlation peak hight
float errar;	//105 error in angular reconstitution,  if -1.0: the file is a special file (FABOSA)
float err3d;	//106 error in 3D reconstruction (TRUE-THREED)
int ref;		//107 (multi-) reference number
float classno;	//108 class number in classification
float locold;	//109 location number before CUT-IMAGE (boxing), or copy in ANGULAR and EX-COPY
float oldavd;	//110 old average density, (before NORM-VARIANCE, for example)
float oldsigma;	//111 old sigma
float xshift;	//112 last shift in X direction
float yshift;	//113 last shift in Y direction
float numcls;	//114 number of class members
float ovqual;	//115 overall class quality, if the image is a class average
float eangle;	//116 equivalent angle
float exshift;	//117 equivalent shift in X direction
float eyshift;	//118 equivalent shift in Y direction
float cmtotvar;	//119 used in MSA/IMAGECOOS
float informat;	//120 Gauss norm / real*FT Space information of the data set
int numeigen;	//121 number of eigen values in MSA
int niactive;	//122 number of active images in MSA
float resolx;	//123 Angstrom per pixel/voxel in X direction,  if DAT1(105) = -1.0 (FABOSA): mm per pixel
float resoly;	//124 Angstrom per pixel/voxel in Y direction
float resolz;	//125 Angstrom per pixel/voxel in Z direction
float alpha2;	//126 Euler angle alpha (from projection matching), Special FABOSA variables if DAT1(105) = -1.0
float beta2;	//127 Euler angle beta (from projection matching), Special FABOSA variables if DAT1(105) = -1.0
float gamma2;	//128 Euler angle gamma (from projection matching), Special FABOSA variables if DAT1(105) = -1.0
float nmetric;	//129 Metric used in MSA calculations
float actmsa;	//130 a flag indicating whether the "image" is active or not. Used during MSA calculations
float coosmsa[69];	//131-199  co-ordinates of "image" along factorial axis
					// number 1 through 69 (maximum possible).
					// Used during MSA calculations.
					//150 eigval,  eigenvalues if the "images" represent eigenimages (eigenvalue #1 into loc#1 etc.)
char history[228];	//220-256 coded history of image (228 characters)
};

#endif
